<?php
/*
Plugin Name: Woocommerce - Request a Quote 
Plugin URI: http://www.20script.ir/
Description: Woocommerce - Request a Quote Plugin
Version: 1.21
Author: 20script
Author URI: http://www.20script.ir/
Text Domain: dvinwcql
*/
/** define constants **/
define("DVIN_QLIST_PLUGIN_WEBURL", plugin_dir_url( __FILE__ ));
define("DVIN_QLIST_PLUGIN_URL", plugin_dir_path( __FILE__ ));
//this array would be used in in determine which hook and priority  to use for which position
$dvin_wcql_link_positions = array('After Add to Cart' =>array('hook_name'=>'woocommerce_single_product_summary','priority'=>30),
						'After Thumbnail' => array('hook_name'=> 'woocommerce_product_thumbnails','priority'=>40),
						'After Product Summary'=>array('hook_name'=>'woocommerce_single_product_summary','priority'=>40),
						'Replace Add To Cart'=>array('hook_name'=>'woocommerce_after_add_to_cart_button','priority'=>40)
						);
//include required files based on admin or site
if (is_admin()) { //for admin
	
	//admin  files 
	require_once(DVIN_QLIST_PLUGIN_URL."class-dvin-wcql.php"); //core class
	include_once(DVIN_QLIST_PLUGIN_URL."class-dvin-wcql-admin.php");
	add_action('admin_init', 'dvin_wcql_admin_initialize');
}  else { // for site
	//enqueue necessary scripts and styles
	add_action( 'wp_enqueue_scripts', 'dvin_qlist_scripts_styles' );
	
	require_once(DVIN_QLIST_PLUGIN_URL."class-dvin-wcql.php"); //core class
	require_once(DVIN_QLIST_PLUGIN_URL."class-dvin-wcql-ui.php");//ui related
	$dvin_wcql_obj = new Dvin_Wcql($_REQUEST);//create object
	//get all settings
	$dvin_wcql_settings = maybe_unserialize(get_option('dvin_wcql_settings'));	
	require_once("class-dvin-wcql-shortcodes.php"); //shortcodes inclusion
	add_action('init', 'dvin_wcql_initialize');
}
/* initializes the plugin in front end **/
function dvin_wcql_admin_initialize() {
	dvin_wcql_localisation();	
}
/* initializes the plugin in front end **/
function dvin_wcql_initialize() {
		
	global $dvin_wcql_settings,$page,$post;
	//load plugin language file
	dvin_wcql_localisation();
	//initialize the seesion if not done yet
	if (!session_id()) {
        session_start();
    }	
	require_once('templates/add-to-quotelist.php');
	
	//replace Add to cart is choosen, means hide the cart button
	if(isset($dvin_wcql_settings['link_position']) && $dvin_wcql_settings['link_position']=='Replace Add To Cart') {
		add_action( 'woocommerce_after_shop_loop_item', 'dvin_qlist_remove_addtocart_button', 12);
	}
	
	//Display button on woocommerce shop page */
	if(isset($dvin_wcql_settings['show_on_shop']) && $dvin_wcql_settings['show_on_shop']=='on'){
		add_action( 'woocommerce_after_shop_loop_item', 'dvin_add_qlist_button_to_shop', 11);
	}
	if(isset($dvin_wcql_settings['show_price_login']) && $dvin_wcql_settings['show_price_login']=='on'){
		if(!is_user_logged_in()){
			add_filter('woocommerce_get_price_html','dvin_qlist_showlogin_price');
			add_filter('woocommerce_get_variation_price','dvin_qlist_showlogin_price');	
		}
		
	}else if(isset($dvin_wcql_settings['no_price']) && $dvin_wcql_settings['no_price']=='on'){
		remove_action( 'woocommerce_after_shop_loop_item_title', 'woocommerce_template_loop_price', 10 );
		add_filter('woocommerce_get_price_html','dvin_qlist_noprice');
		add_filter('woocommerce_get_variation_price','dvin_qlist_noprice');	
	}
	if(isset($dvin_wcql_settings['use_gravity_forms']) && isset($dvin_wcql_settings['gravity_form_select'])) {
		add_action("gform_pre_submission_".$dvin_wcql_settings['gravity_form_select'], "dvin_wcql_set_post_content", 10, 2);
		add_filter("gform_allowable_tags_".$dvin_wcql_settings['gravity_form_select'], "dvin_wcql_allow_basic_tags", 10, 3);
	}
	if(isset($dvin_wcql_settings['use_formidable_forms']) && isset($dvin_wcql_settings['formidable_form_select'])) {
		add_filter('frm_add_entry_meta', 'dvin_wcql_set_formidable_table_content');	
	}
	if(isset($dvin_wcql_settings['no_qty']) && $dvin_wcql_settings['no_qty']=='on'){
		add_action( 'woocommerce_after_shop_loop_item', 'dvin_remove_quantity_box', 13);
	}
}
function dvin_qlist_showlogin_price() {
	
	return apply_filters('dvin_wcql_login_alt_text','call for prices');
}
function dvin_wcql_localisation() {
	//define constants if not
	if(!defined('TEMPLATEPATH'))
		define('TEMPLATEPATH',get_template_directory());
	
	if(!defined('STYLESHEETPATH'))
		define('STYLESHEETPATH',get_stylesheet_directory());
	//include the language file
	if(file_exists(TEMPLATEPATH . '/'. Dvin_Wcql::template_path().'languages/')) {
		$langdir_path = TEMPLATEPATH . '/'. Dvin_Wcql::template_path().'languages/';
	}elseif(file_exists(STYLESHEETPATH . '/'. Dvin_Wcql::template_path().'languages/')) {
		$langdir_path = STYLESHEETPATH . '/'. Dvin_Wcql::template_path().'languages/';
	}else{
		$langdir_path =  dirname( plugin_basename( __FILE__ ) ). '/languages/';
	}
	load_plugin_textdomain( 'dvinwcql', false, $langdir_path ); 
}
function dvin_wcql_allow_basic_tags(){
	return true;
}
/**
* function dvin_add_qlist_button_to_shop, adds button to the products in the shop page
*/
function dvin_add_qlist_button_to_shop() {
	global $product;
    
	if($product->product_type == 'simple'){
		echo do_shortcode('[dvin-wcql-shopbutton product_id='.$product->id.']');
	}
	
}
function dvin_qlist_remove_addtocart_button() {
	 echo "<script>jQuery('.button.add_to_cart_button.product_type_simple').remove();</script>";
}
//register for activate and deactivate hook
register_activation_hook( __FILE__, 'dvin_wcql_activate' );
register_deactivation_hook( __FILE__, 'dvin_wcql_deactivate' );
//function enques necessary scripts and styles
function dvin_qlist_scripts_styles() {
	wp_enqueue_style( 'dvin-wcql-stylesheet', plugins_url('/css/styles.css', __FILE__));
	wp_enqueue_style( 'dvin-wcql-custom_stylesheet', plugins_url('/css/custom_styles.css', __FILE__));
	wp_enqueue_style( 'dashicons' );
	
	//include js file
	if(file_exists(TEMPLATEPATH . '/'. Dvin_Wcql::template_path().'js/dvin_wcql.js')) {
		$js_path = get_template_directory_uri() . '/'. Dvin_Wcql::template_path().'js/dvin_wcql.js';
	}elseif(file_exists(STYLESHEETPATH . '/'. Dvin_Wcql::template_path().'js/dvin_wcql.js')) {
		$js_path = get_stylesheet_directory_uri() . '/'. Dvin_Wcql::template_path().'js/dvin_wcql.js';
	}else{
		$js_path = plugins_url('/js/dvin_wcql.js', __FILE__);
	}
	
	wp_enqueue_script('dvin-wcql-js',$js_path,'jquery','','in_footer');
	
	echo "<script>var dvin_quotelist_count ='".dvin_get_wcql_count()."';var add_to_quotelist_ajax_url = '".add_to_quotelist_url()."';</script>";
	echo '<script>var dvin_wcql_plugin_ajax_prodfind_url = "'.add_query_arg('action','prod_find',DVIN_QLIST_PLUGIN_WEBURL."dvin-wcql-ajax.php").'";
			var login_redirect_url=\''.wp_login_url().'?redirect_to='.urlencode($_SERVER['REQUEST_URI']).'\';
		</script>';	
}
/**
 * function Dvin_Wcql_activate, called at the action hook "register_activation_hook". Creates required tables and sets default preferences
 */
function Dvin_Wcql_activate() {
  global $wpdb; //wpdb var
		//create quotelist page
		$page_data = array(
			'post_status' => 'publish',
			'post_type' => 'page',
			'post_author' => 1,
			'post_name' => 'Quotelist',
			'post_title' => 'Request For a Quote',
			'post_content' => '[dvin-wcql-listing][dvin-wcql-form]',
			'comment_status' => 'closed'
		);
		$quotelistpage_id = wp_insert_post($page_data);
		update_option('dvin_quotelist_pageid', $quotelistpage_id);
	
		//for default settings, if exists, do not create
		if(get_option('dvin_wcql_email_subject')=='') {
			Dvin_Wcql_default_settings();			 //set default settings (excludes email settings)
			update_option('dvin_wcql_email_subject','Sharing [%req_name%] quotelist');
		
			//if Dvin_Wcql_email_msg not exists 
			if(get_option('dvin_wcql_email_msg')=='') {
				update_option('dvin_wcql_email_msg','Hello,
				Following is the quote list of the [%req_name%]:
				[%quotelist%]
                               Comments: [%comments%]
Thanks,
[%req_name%]');
				}//end if
		}//end if
}//end of function
/** function Dvin_Wcql_default_settings - sets the default settings for the plugin options **/
function Dvin_Wcql_default_settings() {
	$settings_arr = array();
	$settings_arr['link_position'] = 'After Add to Cart';
	$settings_arr['link_bgcolor'] = '#000000';
	$settings_arr['link_fontcolor'] = '#FFFFFF';
	$settings_arr['link_sameas_addtocart_default_colors'] = 'on';
	$settings_arr['redirect_to_cart'] = '';
	$settings_arr['link_sameas_addtocart'] = 'on';
	$settings_arr['show_quotelist_link_always'] = 'on';
	$settings_arr['custom_css'] = '.addquotelistlink{}';
	update_option('dvin_wcql_settings',maybe_serialize($settings_arr));
	//update the custom_styles file
	file_put_contents(DVIN_QLIST_PLUGIN_URL."css/custom_styles.css",$settings_arr['custom_css']);
}
/**
 * function dvin_get_wcql_count, rteurn the number of products in quotelist
 *@return integer number of products in quotelist
 */
function dvin_get_wcql_count() {
	if(isset($_SESSION['dvin_qlist_products'])) {
		foreach($_SESSION['dvin_qlist_products'] as $key=>$value)
			if($key == '')
				unset($_SESSION['dvin_qlist_products'][$key]);
		return count($_SESSION['dvin_qlist_products']);
	}
}
//called by deactivate hook, do thye necessary stuff
function Dvin_Wcql_deactivate() {	
	//delete pages created for this plugin
	wp_delete_post(get_option('dvin_quotelist_pageid'),true);
}
/**
* function add_to_quotelist_url, Builds add to quotelist URL
* @string URL 
 */
function add_to_quotelist_url() {
	return DVIN_QLIST_PLUGIN_WEBURL."dvin-wcql-ajax.php";
}
/** Adds quotelist button/link to the single product page based on position selection**/
function dvin_addquotelist_button($shopbutton=false,$product_id='') {
	
	global $product,$dvin_wcql_obj;
	$output = '';
	//if not a shop button
	if(!$shopbutton) {
	
		//if product type is variable, get link based on it
		if($product->product_type !='variable') {
			//set the product ID
			$product_id = $product->id;
			$output .=	Dvin_Wcql_UI::get_qlist_link($dvin_wcql_obj->get_url(),$product->product_type,$dvin_wcql_obj->isExists($product->id, ''));
		}else {
				$output .=  Dvin_Wcql_UI::get_qlist_link($dvin_wcql_obj->get_url(),$product->product_type,false);
		}
		//have message popup to display the messages	
		$output .=  Dvin_Wcql_UI::get_message_poupup_container(250,190);
	}else {
		$output .=  Dvin_Wcql_UI::get_qlist_shoplink($dvin_wcql_obj->get_url(),'simple',$dvin_wcql_obj->isExists($product_id, ''),$product_id);
	}

	//if shopbutton return output
	if($shopbutton)
		return $output;
	else
		echo $output;
}
/** removes the  Add to Cart button **/
function dvin_remove_addtocart_button() {
	echo "<script>jQuery('.single_add_to_cart_button').remove();</script>";
}
//removes the quantity selector or box
function dvin_remove_quantity_box() {
	echo "<script>jQuery('.input-text.qty.text').remove();</script>";
}
function dvin_qlist_quantity_input( $input_name, $input_value, $args = array(), $product = null, $echo = true ) {
		if ( is_null( $product ) )
			$product = $GLOBALS['product'];
		$defaults = array(
			'input_name'  	=> $input_name,
			'input_value'  	=> $input_value,
			'max_value'  	=> apply_filters( 'woocommerce_quantity_input_max',$product->backorders_allowed()),
			'min_value'  	=> apply_filters( 'woocommerce_quantity_input_min', '1', $product ),
			'step' 			=> apply_filters( 'woocommerce_quantity_input_step', '1', $product )
		);
		ob_start();
		//template for the quantity
		if(function_exists('wc_get_template')) {//works for WC 2.1+
			wc_get_template( 'global/quantity-input.php', $defaults );
		} else {//works for WC 2.0
			woocommerce_get_template( 'single-product/add-to-cart/quantity.php', $defaults );
		}
		
		if ( $echo ) {
			echo ob_get_clean();
		} else {
			return ob_get_clean();
		}
	}
	function dvin_qlist_noprice() {
		return '';
	}
	 function dvin_wcql_set_post_content($form){
		$total_price = 0; //this variable is not useful but declaring to just to accept the return value from the get_qlist_table function
	 	$fields = $form['fields'];
	 	foreach($fields as $arr){
	 		if($arr['defaultValue']=='[quotelisttable]')
	 			list($total_price,$_POST['input_'.$arr['id']]) = get_qlist_table();
	 	}
	 	$_SESSION['dvin_qlist_products']=array();
	 }
 
	function gf_quotelist($value){
	    return do_shortcode('[dvin-wcql-listing]');
	}
	function dvin_wcql_set_formidable_table_content($new_values) {
		global $dvin_wcql_settings;
		$total_price = 0; //this variable is not useful but declaring to just to accept the return value from the get_qlist_table function
	
			if($new_values['meta_value'] == '[quotelisttable]') {
				list($total_price,$new_values['meta_value']) = get_qlist_table();
				$_SESSION['dvin_qlist_products']=array();		
			}
		return $new_values;
	}
	function get_qlist_table() {
		
		global $product,$dvin_wcql_settings;

		//get the all the style values
		$dvin_wcql_email_tbl_style = get_option('dvin_wcql_email_tbl_style');
		$dvin_wcql_email_tbl_hdr_style = get_option('dvin_wcql_email_tbl_hdr_style');
		$dvin_wcql_email_tbl_row_style = get_option('dvin_wcql_email_tbl_row_style');
		$dvin_wcql_email_tbl_cell_style = get_option('dvin_wcql_email_tbl_cell_style');

		//include the template file
		if(file_exists(TEMPLATEPATH . '/'. Dvin_Wcql::template_path().'templates/email_quotelist_template.php')) {
			include(TEMPLATEPATH . '/'. Dvin_Wcql::template_path().'templates/email_quotelist_template.php');
		}elseif(file_exists(STYLESHEETPATH . '/'. Dvin_Wcql::template_path().'templates/email_quotelist_template.php')) 		{
			include(STYLESHEETPATH . '/'. Dvin_Wcql::template_path().'templates/email_quotelist_template.php');
		}else{
			require('templates/email_quotelist_template.php');
		}
		return array($grand_total_price,$quote_list);
	}

?>